vsg: vsg::Object Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
vsg::Object Class Reference

Inherited by vsg::Inherit< Object, AccelerationGeometry >, vsg::Inherit< Object, AccelerationStructure >, vsg::Inherit< Object, ActivityStatus >, vsg::Inherit< Object, AllocationCallbacks >, vsg::Inherit< Object, Animation >, vsg::Inherit< Object, AnimationManager >, vsg::Inherit< Object, ArrayConfigurator >, vsg::Inherit< Object, Barrier >, vsg::Inherit< Object, Buffer >, vsg::Inherit< Object, BufferInfo >, vsg::Inherit< Object, BufferMemoryBarrier >, vsg::Inherit< Object, BufferView >, vsg::Inherit< Object, Builder >, vsg::Inherit< Object, CameraKeyframes >, vsg::Inherit< Object, CommandBuffer >, vsg::Inherit< Object, CommandPool >, vsg::Inherit< Object, CompileManager >, vsg::Inherit< Object, ComputePipeline >, vsg::Inherit< Object, Implementation >, vsg::Inherit< Object, Context >, vsg::Inherit< Object, CulledPagedLODs >, vsg::Inherit< Object, CustomDescriptorSetBinding >, vsg::Inherit< Object, DatabasePager >, vsg::Inherit< Object, DatabaseQueue >, vsg::Inherit< Object, DeleteQueue >, vsg::Inherit< Object, Descriptor >, vsg::Inherit< Object, DescriptorConfigurator >, vsg::Inherit< Object, DescriptorPool >, vsg::Inherit< Object, DescriptorPools >, vsg::Inherit< Object, DescriptorSet >, vsg::Inherit< Object, DescriptorSetLayout >, vsg::Inherit< Object, Device >, vsg::Inherit< Object, DeviceExtensions >, vsg::Inherit< Object, DeviceFeatures >, vsg::Inherit< Object, DeviceMemory >, vsg::Inherit< Object, EllipsoidModel >, vsg::Inherit< Object, Event >, vsg::Inherit< Object, External >, vsg::Inherit< Object, Fence >, vsg::Inherit< Object, Font >, vsg::Inherit< Object, FrameBlock >, vsg::Inherit< Object, FrameStamp >, vsg::Inherit< Object, Framebuffer >, vsg::Inherit< Object, GeometryInstance >, vsg::Inherit< Object, GraphicsPipeline >, vsg::Inherit< Object, GraphicsPipelineConfigurator >, vsg::Inherit< Object, GraphicsPipelineState >, vsg::Inherit< Object, Image >, vsg::Inherit< Object, ImageInfo >, vsg::Inherit< Object, ImageMemoryBarrier >, vsg::Inherit< Object, ImageView >, vsg::Inherit< Object, Instance >, vsg::Inherit< Object, InstanceExtensions >, vsg::Inherit< Object, Instrumentation >, vsg::Inherit< Object, Latch >, vsg::Inherit< Object, Intersection >, vsg::Inherit< Object, LoadedObject >, vsg::Inherit< Object, MemoryBarrier >, vsg::Inherit< Object, MemoryBufferPools >, vsg::Inherit< Object, MorphKeyframes >, vsg::Inherit< Object, Node >, vsg::Inherit< Object, Objects >, vsg::Inherit< Object, OperationThreads >, vsg::Inherit< Object, Options >, vsg::Inherit< Object, PagedLODContainer >, vsg::Inherit< Object, PhysicalDevice >, vsg::Inherit< Object, PipelineLayout >, vsg::Inherit< Object, Presentation >, vsg::Inherit< Object, ProfileLog >, vsg::Inherit< Object, ProjectionMatrix >, vsg::Inherit< Object, QueryPool >, vsg::Inherit< Object, Queue >, vsg::Inherit< Object, RayTracingPipeline >, vsg::Inherit< Object, RayTracingShaderGroup >, vsg::Inherit< Object, ReadError >, vsg::Inherit< Object, ReaderWriter >, vsg::Inherit< Object, RecordAndSubmitTask >, vsg::Inherit< Object, RecordedCommandBuffers >, vsg::Inherit< Object, RenderPass >, vsg::Inherit< Object, ResourceHints >, vsg::Inherit< Object, Sampler >, vsg::Inherit< Object, ScratchMemory >, vsg::Inherit< Object, Semaphore >, vsg::Inherit< Object, ShaderCompileSettings >, vsg::Inherit< Object, ShaderModule >, vsg::Inherit< Object, ShaderSet >, vsg::Inherit< Object, ShaderStage >, vsg::Inherit< Object, ShadowSettings >, vsg::Inherit< Object, SharedObjects >, vsg::Inherit< Object, State >, vsg::Inherit< Object, Surface >, vsg::Inherit< Object, Swapchain >, vsg::Inherit< Object, TextLayout >, vsg::Inherit< Object, TextTechnique >, vsg::Inherit< Object, ThreadSafeQueue< T > >, vsg::Inherit< Object, TileDatabaseSettings >, vsg::Inherit< Object, TracySettings >, vsg::Inherit< Object, TransferTask >, vsg::Inherit< Object, TransferBlock >, vsg::Inherit< Object, TransformKeyframes >, vsg::Inherit< Object, UIEvent >, vsg::Inherit< Object, UpdateOperations >, vsg::Inherit< Object, ViewDependentState >, vsg::Inherit< Object, ViewMatrix >, vsg::Inherit< Object, Viewer >, vsg::Inherit< Object, VulkanInfo >, vsg::Inherit< Object, Window >, vsg::Inherit< Object, WindowTraits >, vsg::ConstVisitor, vsg::Data, vsg::Duplicate, vsg::Logger, vsg::ObjectFactory, vsg::Operation, vsg::RecordTraversal, vsg::Visitor, vsgAndroid::KeyboardMap, vsgMacOS::KeyboardMap, vsgWin32::KeyboardMap, vsgXcb::KeyboardMap, and vsgiOS::KeyboardMap.

## Public Member Functions
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
virtual std::size_t | sizeofObject () const noexcept
virtual const char * | className () const noexcept
virtual const std::type_info & | type_info () const noexcept
| return the std::type_info of this Object
virtual bool | is_compatible (const std::type_info &type) const noexcept
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual int | compare (const Object &rhs) const
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
virtual void | accept (Visitor &visitor)
virtual void | traverse (Visitor &)
virtual void | accept (ConstVisitor &visitor) const
virtual void | traverse (ConstVisitor &) const
virtual void | accept (RecordTraversal &visitor) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Protected Member Functions
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Friends
class | Auxiliary

## Member Function Documentation

## ◆ accept()

virtual void vsg::Object::accept | ( | RecordTraversal & | visitor | ) | const
| virtual

Reimplemented in vsg::RenderGraph.

## ◆ clone()

virtual ref_ptr< Object > vsg::Object::clone | ( | const CopyOp & | copyop = {} | ) | const
| virtual

clone this object using CopyOp's duplicates map to decide whether to clone or to return the original object. The default clone(CopyOp&) implementation simply returns ref_ptr<> to this object rather attempt to clone.

Reimplemented in vsg::AbsoluteTransform, vsg::AmbientLight, vsg::Animation, vsg::AnimationGroup, vsg::Array2D< T >, vsg::Array3D< T >, vsg::Array< T >, vsg::Bin, vsg::BindDescriptorSet, vsg::BindDescriptorSets, vsg::BufferInfo, vsg::CameraSampler, vsg::CoordinateFrame, vsg::CullGroup, vsg::CullNode, vsg::DepthSorted, vsg::DescriptorBuffer, vsg::DescriptorImage, vsg::DescriptorSet, vsg::DescriptorSetLayout, vsg::DescriptorTexelBufferView, vsg::DirectionalLight, vsg::Geometry, vsg::Group, vsg::HardShadows, vsg::InstrumentationNode, vsg::Joint, vsg::JointSampler, vsg::Layer, vsg::Light, vsg::LOD, vsg::LookAt, vsg::LookDirection, vsg::MatrixTransform, vsg::MorphSampler, vsg::Node, vsg::Orthographic, vsg::PagedLOD, vsg::PercentageCloserSoftShadows, vsg::Perspective, vsg::PipelineLayout, vsg::PointLight, vsg::QuadGroup, vsg::RegionOfInterest, vsg::ShadowSettings, vsg::SoftShadows, vsg::SpotLight, vsg::StateGroup, vsg::StateSwitch, vsg::Switch, vsg::TileDatabase, vsg::TileDatabaseSettings, vsg::TransformSampler, vsg::Value< T >, vsg::VertexDraw, vsg::VertexIndexDraw, and vsg::WindowTraits.

## ◆ compare()

virtual int vsg::Object::compare | ( | const Object & | rhs | ) | const
| virtual

compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,

Reimplemented in vsg::AbsoluteTransform, vsg::Animation, vsg::AnimationGroup, vsg::AnimationSampler, vsg::ArrayConfigurator, vsg::Bin, vsg::BindComputePipeline, vsg::BindDescriptorSet, vsg::BindDescriptorSets, vsg::BindGraphicsPipeline, vsg::BindIndexBuffer, vsg::BindRayTracingPipeline, vsg::BindVertexBuffers, vsg::BindViewDescriptorSets, vsg::BufferInfo, vsg::BufferView, vsg::CameraSampler, vsg::ColorBlendState, vsg::Commands, vsg::ComputePipeline, vsg::CoordinateFrame, vsg::CullGroup, vsg::CullNode, vsg::CustomDescriptorSetBinding, vsg::Data, vsg::DepthSorted, vsg::DepthStencilState, vsg::Descriptor, vsg::DescriptorBuffer, vsg::DescriptorConfigurator, vsg::DescriptorImage, vsg::DescriptorSet, vsg::DescriptorSetLayout, vsg::DescriptorTexelBufferView, vsg::DirectionalLight, vsg::Draw, vsg::DrawIndexed, vsg::DynamicState, vsg::Geometry, vsg::GraphicsPipeline, vsg::GraphicsPipelineConfigurator, vsg::GraphicsPipelineState, vsg::Group, vsg::HardShadows, vsg::Image, vsg::ImageInfo, vsg::ImageView, vsg::InputAssemblyState, vsg::InstrumentationNode, vsg::Joint, vsg::JointSampler, vsg::Layer, vsg::Light, vsg::LoadedObject, vsg::LOD, vsg::MatrixTransform, vsg::MorphSampler, vsg::MultisampleState, vsg::Options, vsg::PagedLOD, vsg::PercentageCloserSoftShadows, vsg::PipelineLayout, vsg::PointLight, vsg::QuadGroup, vsg::RasterizationState, vsg::RayTracingPipeline, vsg::RegionOfInterest, vsg::Sampler, vsg::ShaderCompileSettings, vsg::ShaderModule, vsg::ShaderSet, vsg::ShaderStage, vsg::ShadowSettings, vsg::SoftShadows, vsg::SpotLight, vsg::StateCommand, vsg::StateGroup, vsg::StateSwitch, vsg::Switch, vsg::TessellationState, vsg::TextGroup, vsg::TileDatabase, vsg::TileDatabaseSettings, vsg::Transform, vsg::TransformSampler, vsg::VertexDraw, vsg::VertexIndexDraw, vsg::VertexInputState, vsg::ViewDependentStateBinding, vsg::ViewDescriptorSetLayout, and vsg::ViewportState.

## ◆ setValue()

template<typename T>

void vsg::Object::setValue | ( | const std::string & | key,
|  | const T & | value )

meta data access methods wraps the value with a vsg::Value<T> object and then assigns via setObject(key, vsg::Value<T>)

## ◆ type_info()

virtual const std::type_info & vsg::Object::type_info | ( |  | ) | const
| inlinevirtualnoexcept

return the std::type_info of this Object

Reimplemented in vsg::Array2D< T >, vsg::Array3D< T >, vsg::Array< T >, and vsg::Value< T >.

The documentation for this class was generated from the following files:

- include/vsg/core/Object.h
- include/vsg/core/Value.h